# JobDetailsApi

All URIs are relative to *https://service.fax-api.de/4.0/rest*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getJob**](JobDetailsApi.md#getJob) | **GET** /jobs/{id} | /jobs/{id}
[**getJobNotifications**](JobDetailsApi.md#getJobNotifications) | **GET** /jobs/{id}/notifications | /jobs/{id}/notifications
[**getJobPreviews**](JobDetailsApi.md#getJobPreviews) | **GET** /jobs/{id}/preview | /jobs/{id}/preview
[**getJobRecipients**](JobDetailsApi.md#getJobRecipients) | **GET** /jobs/{id}/recipients | /jobs/{id}/recipients
[**getJobTemplates**](JobDetailsApi.md#getJobTemplates) | **GET** /jobs/{id}/templates | /jobs/{id}/templates
[**putJob**](JobDetailsApi.md#putJob) | **PUT** /jobs/{id} | /jobs/{id}

<a name="getJob"></a>
# **getJob**
> Job getJob(id)

/jobs/{id}

Description: Obtain information of a specific job

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.JobDetailsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: ApiAuthKey
ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
ApiAuthKey.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//ApiAuthKey.setApiKeyPrefix("Token");

JobDetailsApi apiInstance = new JobDetailsApi();
String id = "id_example"; // String | Identification number (UUID) of the job
try {
    Job result = apiInstance.getJob(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling JobDetailsApi#getJob");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Identification number (UUID) of the job |

### Return type

[**Job**](Job.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getJobNotifications"></a>
# **getJobNotifications**
> Notifications getJobNotifications(id)

/jobs/{id}/notifications

Description: To obtain a list of notifications to a specific job

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.JobDetailsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: ApiAuthKey
ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
ApiAuthKey.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//ApiAuthKey.setApiKeyPrefix("Token");

JobDetailsApi apiInstance = new JobDetailsApi();
String id = "id_example"; // String | Identification number (UUID) of the job
try {
    Notifications result = apiInstance.getJobNotifications(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling JobDetailsApi#getJobNotifications");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Identification number (UUID) of the job |

### Return type

[**Notifications**](Notifications.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getJobPreviews"></a>
# **getJobPreviews**
> Preview getJobPreviews(id)

/jobs/{id}/preview

Description: To obtain the preview pdf document of a specific job

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.JobDetailsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: ApiAuthKey
ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
ApiAuthKey.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//ApiAuthKey.setApiKeyPrefix("Token");

JobDetailsApi apiInstance = new JobDetailsApi();
String id = "id_example"; // String | Identification number (UUID) of the job
try {
    Preview result = apiInstance.getJobPreviews(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling JobDetailsApi#getJobPreviews");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Identification number (UUID) of the job |

### Return type

[**Preview**](Preview.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getJobRecipients"></a>
# **getJobRecipients**
> JobRecipients getJobRecipients(id, objectLimit, objectOffset, filterFaxNumber, filterFaxNumberNorm, filterRecipientReference, filterInternationalDialingCode, filterResultCode, filterResultText, sortField, sortOrder)

/jobs/{id}/recipients

Description: Resource to obtain a list of recipients to a specific job

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.JobDetailsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: ApiAuthKey
ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
ApiAuthKey.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//ApiAuthKey.setApiKeyPrefix("Token");

JobDetailsApi apiInstance = new JobDetailsApi();
String id = "id_example"; // String | Identification number (UUID) of the job
Integer objectLimit = 100; // Integer | Query parameter to change de default limitation of objects in the result data array
Integer objectOffset = 0; // Integer | Query parameter to change de default offset of objects in the result data array
String filterFaxNumber = "filterFaxNumber_example"; // String | Query parameter to fetch recipients after his fax number
String filterFaxNumberNorm = "filterFaxNumberNorm_example"; // String | Query parameter to fetch recipients after his normed fax number
String filterRecipientReference = "filterRecipientReference_example"; // String | Query parameter to fetch recipients after his recipient reference
String filterInternationalDialingCode = "filterInternationalDialingCode_example"; // String | Query parameter to fetch recipients after his international dialing code
String filterResultCode = "filterResultCode_example"; // String | Query parameter to fetch recipients after his result code
String filterResultText = "filterResultText_example"; // String | Query parameter to fetch recipients after his result text
String sortField = "sortField_example"; // String | Available sort options for the result data array.
String sortOrder = "asc"; // String | Describes the order for used sort fields
try {
    JobRecipients result = apiInstance.getJobRecipients(id, objectLimit, objectOffset, filterFaxNumber, filterFaxNumberNorm, filterRecipientReference, filterInternationalDialingCode, filterResultCode, filterResultText, sortField, sortOrder);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling JobDetailsApi#getJobRecipients");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Identification number (UUID) of the job |
 **objectLimit** | **Integer**| Query parameter to change de default limitation of objects in the result data array | [optional] [default to 100] [enum: ]
 **objectOffset** | **Integer**| Query parameter to change de default offset of objects in the result data array | [optional] [default to 0] [enum: ]
 **filterFaxNumber** | **String**| Query parameter to fetch recipients after his fax number | [optional]
 **filterFaxNumberNorm** | **String**| Query parameter to fetch recipients after his normed fax number | [optional]
 **filterRecipientReference** | **String**| Query parameter to fetch recipients after his recipient reference | [optional]
 **filterInternationalDialingCode** | **String**| Query parameter to fetch recipients after his international dialing code | [optional]
 **filterResultCode** | **String**| Query parameter to fetch recipients after his result code | [optional]
 **filterResultText** | **String**| Query parameter to fetch recipients after his result text | [optional]
 **sortField** | **String**| Available sort options for the result data array. | [optional] [enum: faxNumber, faxNumberNorm, internationalDialingCode, recipientReference, fareZone, senderTime]
 **sortOrder** | **String**| Describes the order for used sort fields | [optional] [default to asc] [enum: asc, desc]

### Return type

[**JobRecipients**](JobRecipients.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getJobTemplates"></a>
# **getJobTemplates**
> Templates getJobTemplates(id)

/jobs/{id}/templates

Description: To obtain a list of template documents to a specific job

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.JobDetailsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: ApiAuthKey
ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
ApiAuthKey.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//ApiAuthKey.setApiKeyPrefix("Token");

JobDetailsApi apiInstance = new JobDetailsApi();
String id = "id_example"; // String | Identification number (UUID) of the job
try {
    Templates result = apiInstance.getJobTemplates(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling JobDetailsApi#getJobTemplates");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Identification number (UUID) of the job |

### Return type

[**Templates**](Templates.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="putJob"></a>
# **putJob**
> Job putJob(body, id)

/jobs/{id}

Description: Control the transmission of the specific job

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.JobDetailsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: ApiAuthKey
ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
ApiAuthKey.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//ApiAuthKey.setApiKeyPrefix("Token");

JobDetailsApi apiInstance = new JobDetailsApi();
JobsIdBody body = new JobsIdBody(); // JobsIdBody | Describes the required request body to perform an action on the fax job
String id = "id_example"; // String | Identification number (UUID) of the job
try {
    Job result = apiInstance.putJob(body, id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling JobDetailsApi#putJob");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**JobsIdBody**](JobsIdBody.md)| Describes the required request body to perform an action on the fax job |
 **id** | **String**| Identification number (UUID) of the job |

### Return type

[**Job**](Job.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

