/*
 * Faxsuite RESTful API
 * <p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  
 *
 * OpenAPI spec version: 4.0.0
 * Contact: support@fax-api.de
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.JobInfo;
import io.swagger.client.model.JobOptions;
import io.swagger.client.model.JobStatistics;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
/**
 * Describes the job information sent by querying them
 */
@Schema(description = "Describes the job information sent by querying them")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-05-09T10:16:59.047+02:00[Europe/Berlin]")
public class Job {
  @SerializedName("id")
  private String id = null;

  @SerializedName("account")
  private String account = null;

  /**
   * Describes the current state of the fax job
   */
  @JsonAdapter(StatusEnum.Adapter.class)
  public enum StatusEnum {
    SCHEDULING("scheduling"),
    SCHEDULED("scheduled"),
    PROCESSING("processing"),
    HALTED("halted"),
    LOCKED("locked"),
    CANCELED("canceled"),
    FINISHED("finished"),
    ERROR("error");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static StatusEnum fromValue(String input) {
      for (StatusEnum b : StatusEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<StatusEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final StatusEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public StatusEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return StatusEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("status")
  private StatusEnum status = null;

  @SerializedName("errorCode")
  private Integer errorCode = null;

  @SerializedName("options")
  private JobOptions options = null;

  @SerializedName("info")
  private JobInfo info = null;

  @SerializedName("statistics")
  private JobStatistics statistics = null;

  public Job id(String id) {
    this.id = id;
    return this;
  }

   /**
   * Describes the identification number (UUID) of a fax job
   * @return id
  **/
  @Schema(example = "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx", description = "Describes the identification number (UUID) of a fax job")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public Job account(String account) {
    this.account = account;
    return this;
  }

   /**
   * Describes the account the job does belongs to
   * @return account
  **/
  @Schema(example = "ApiAccount123", description = "Describes the account the job does belongs to")
  public String getAccount() {
    return account;
  }

  public void setAccount(String account) {
    this.account = account;
  }

  public Job status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * Describes the current state of the fax job
   * @return status
  **/
  @Schema(description = "Describes the current state of the fax job")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public Job errorCode(Integer errorCode) {
    this.errorCode = errorCode;
    return this;
  }

   /**
   * If status is equal to &#x27;error&#x27; this field contains the error code number
   * @return errorCode
  **/
  @Schema(example = "503", description = "If status is equal to 'error' this field contains the error code number")
  public Integer getErrorCode() {
    return errorCode;
  }

  public void setErrorCode(Integer errorCode) {
    this.errorCode = errorCode;
  }

  public Job options(JobOptions options) {
    this.options = options;
    return this;
  }

   /**
   * Get options
   * @return options
  **/
  @Schema(description = "")
  public JobOptions getOptions() {
    return options;
  }

  public void setOptions(JobOptions options) {
    this.options = options;
  }

  public Job info(JobInfo info) {
    this.info = info;
    return this;
  }

   /**
   * Get info
   * @return info
  **/
  @Schema(description = "")
  public JobInfo getInfo() {
    return info;
  }

  public void setInfo(JobInfo info) {
    this.info = info;
  }

  public Job statistics(JobStatistics statistics) {
    this.statistics = statistics;
    return this;
  }

   /**
   * Get statistics
   * @return statistics
  **/
  @Schema(description = "")
  public JobStatistics getStatistics() {
    return statistics;
  }

  public void setStatistics(JobStatistics statistics) {
    this.statistics = statistics;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Job job = (Job) o;
    return Objects.equals(this.id, job.id) &&
        Objects.equals(this.account, job.account) &&
        Objects.equals(this.status, job.status) &&
        Objects.equals(this.errorCode, job.errorCode) &&
        Objects.equals(this.options, job.options) &&
        Objects.equals(this.info, job.info) &&
        Objects.equals(this.statistics, job.statistics);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, account, status, errorCode, options, info, statistics);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Job {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    account: ").append(toIndentedString(account)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    errorCode: ").append(toIndentedString(errorCode)).append("\n");
    sb.append("    options: ").append(toIndentedString(options)).append("\n");
    sb.append("    info: ").append(toIndentedString(info)).append("\n");
    sb.append("    statistics: ").append(toIndentedString(statistics)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
